<?php

require_once "../lib/Proposition.php";
require_once "../lib/Action.php";
require_once "../lib/WSObject.php";
require_once "../lib/Decisions.php";

class Poll {
    function fillFromDB($db, $poll_id) {
        //This is a bit complex because we're making a nested OO-ish data 
        // structure (PHP), Out of flat relational tables (MySQL)
      /* $q = "SELECT * FROM polls LEFT JOIN folio_items fi
           LEFT JOIN tags ON tags.item_id = fi.item_id
           ON fi.indiv_type_id = polls.poll_id 
           WHERE fi.type_id = 4 AND polls.poll_id=$poll_id";
      
      This commented out part was the original query which was not working 
      due to a syntax error.  I'm going to try different syntax below to fix it...
      */
      $q = "SELECT * FROM polls LEFT JOIN folio_items ON folio_items.indiv_type_id = polls.poll_id
           LEFT JOIN tags ON tags.item_id = folio_items.item_id
           WHERE folio_items.type_id = 4 AND polls.poll_id=$poll_id";
      //OK so this new query above worked... whew... but i'm going to leave
      //the other one commented out above incase something goes wrong.
        $pollrow = $db->getRow($q);
        $this->fillFromRow($pollrow);

        $proprows = $db->getAll("SELECT * FROM props WHERE poll_id=$poll_id
                                 ORDER BY prop_id");
        $this->props = Array();
        foreach($proprows as $proprow) {
            $newprop = new Proposition;
            $newprop->fillFromRow($proprow);
            $newprop->fillNonrowItemsFromDB($db);
            $this->props[$newprop->prop_id] = $newprop;
        }

        $uservoterows = $db->getAll("SELECT * FROM userpolls 
                                     WHERE poll_id=$poll_id
                                     ORDER BY when_voted");
        $this->userVotes = Array();
        foreach($uservoterows as $row) {
//             echo 'a row in here<BR>';
//             echo $row['username'] . "<BR>";
            $this->userVotes[$row['username']] = newUserVoteFromRow($row);
        }
//         printr($this); echo "----------------------------";
    }
    
    function fillFromRow($row) {
      $this->unix_when_created = strtotime($row['when_created']);
        foreach ($row as $k => $v) {
            $this->$k = $v;
        }
//         echo "drule str: $row[drule] <BR>";
//         echo "tally str: $row[tally] <BR>";
        $this->drule = unserialize($row['drule']);
        $this->tally = unserialize($row['tally']);
    }

    function isOpen() {
        return $this->is_open;
            //strtotime($this->when_closes) < time();
    }
    
    function closePoll($db, $byWho = "", $msg="") {
        global $CURGROUP;
        echo "CURGROUP:\n";
        print_r($CURGROUP);
        
        $this->is_open = 0;
        $db->query("UPDATE polls SET is_open = 0
                    WHERE poll_id = $this->poll_id");
        $this->doActions($db);

        
        $PorV  = $this->is_straw ? "Poll" : "Vote";
        $porv2  = $this->is_straw ? "poll" : "vote";
        $subj = "$PorV Has Closed";
        if (!$msg && !$byWho) {
            $msg =  "This $porv2 was automatically closed at ".strftime("%c");
        } else {
            if (strtotime($this->when_created) > time()) {
                $subj = "$PorV Has Closed Early";
            }
            if (!$byWho) {
                $byWho = "Automatic Post";
            }
        }
        $q = "INSERT msgs SET
               subj           = '".addslashes($subj)."',
               msgtext        = '".addslashes($msg)."',
               discoowner_id  = $this->marea_id,
               when_posted    = NOW(),
               author         = '".addslashes($byWho)."'
        ";
        $db->query($q); //Still needs primary_ref_id
        $msg_id = $db->getOne("SELECT LAST_INSERT_ID()");
        $q = "INSERT refs SET
               referrer_type = 'msg',
               referrer_id   = $msg_id,
               referrent_type= 'poll',
               referrent_id  = $this->poll_id
        ";
        $db->query($q);
        //$ref_id = $db->getOne("SELECT LAST_INSERT_ID()"); //to be commented out if below works.
        $q = "SELECT orig_preface_ref_id FROM polls WHERE polls.poll_id = $this->poll_id";
        $ref_id = $db->getOne($q);    //   <<< this addition needs to be made, but I'm having trouble doing it  
        $q = "UPDATE msgs SET
               primary_ref_id = $ref_id
              WHERE msg_id = $msg_id";
        $db->query($q);
        $this->closer_msg_id = $msg_id;
        $this->closer_ref_id = $ref_id;
        $q = "UPDATE polls SET
               closer_msg_id = $msg_id,
               closer_ref_id = $ref_id
              WHERE poll_id = $this->poll_id";
        $db->query($q);

        //----- external email notification
        $notice = new AnnounceCloseNotice;
        //same $subj
        $body = "$PorV #".$this->poll_id." on \"".$this->title."\" was closed
at ".strftime("%c")."

";
        $body .= $this->getResultsReportText();
        $body .= "

See full $porv2 results: ".$CURGROUP->getUrlRoot()."/marea?obj_id=".$this->poll_id."&obj_type=poll&marea_id=".$this->marea_id;

        $notice->notify($subj,$body);

        return $msg_id;
    }

    function getResultsReportText() {
        return $this->tally->getResultsReportText($this);
    }
    function doActions($db) {
        $winners =& $this->drule->evaluate($this);
        if(count($winners) == 0) {
        } else if(count($winners) == 1) {
        } else if(count($winners) > 1) {
        }
        foreach($winners as $winner) {
            foreach($winner->actions as $action) {
                $action->doAction($db, $this, $winner);
            }
        }
    }
            
    
    function viewForWorkspace() {
        global $drules, $pollingMethods; //from Decisions.php
        echo "<table class=poll_display><tr><td>";

        $this->tally->viewAsSummary($this);
        $this->tally->viewAsBreakdown($this);

        echo "<br>";
        if(! $this->is_straw) {
            echo "<a target=_new href=fullpollview.php?poll_id=".$this->poll_id.">";
            echo "See all implementation details<BR>";
            echo "</a>";
            echo "<br>";
        }
        echo "Polling Method: ".$pollingMethods[$this->method_type]['longname'];
        echo "<br>";
        echo "Decision Rule: ".$drules[$this->drule_type]['longname'];
        echo "</table>";
    }
       
    function viewAsFull() {
        global $drules, $pollingMethods; //from Decisions.php
        echo "<table class=poll_display><tr><td>";

        echo "Polling Method: ".$pollingMethods[$this->method_type]['longname'];
        echo "<br>";
        echo "Decision Rule: ".$drules[$this->drule_type]['longname'];
        echo "<br>";
        echo "<br>";
        $this->tally->viewChoicesWithDetails($this);
        $this->tally->viewAsBreakdown($this);
        echo "</table>";
    }

    function viewAsBallot(&$curuservote) {
        if (!$curuservote->hasVoted()) {
            echo "<H1>Make your vote</h1>";
        } else {
            echo "<H1>Change your vote</h1>";
        }
        echo "<table class=poll_display><tr><td>";
        echo "<h2>" . $this->title . "</h2>";
        echo "<form method=POST ";
        echo "action=ballot-submit.php?poll_id=".$this->poll_id.">";  //"&show_confirmation=0>";
        $this->tally->viewAsBallotOptions($this, $curuservote);
        echo "<BR><B>Comments on your vote:</B> ";
        echo "<font size=-1>Place any explanation or clarifications here.";
        echo "What you write will appear as a comment for ";
        echo "everyone in the meeting area to see.</font><BR>";
        echo "<textarea name=msgtext class=msgtext";
        echo "  style=\"width:100%\" rows=6>";
        echo htmlspecialchars($curuservote->msgtext);
        echo "</textarea>";
        echo "<input type=submit name=submit value=\"Vote\">";
        echo "</form>";
        echo "Note: this poll allows you to change your vote until it closes.<BR>";
        echo "</table>";
    }

    function getPrefaceText($db) {
      return $this->preface_text;
    }
        


    /* processVoteSubmission() gets called by the page coming after the one
     * with viewAsBallot() embedded within it.
     */
    function processVoteSubmission($db, &$post, $username) {
        $res = Array();
        $uservote =& $this->userVotes[$username];
        $oldUservote = $uservote; //Copy.

        $uservote->processVoteSubmission($db, $post);

        $this->tallyNewVoteThenUpdate($db, $oldUservote, $uservote);
   
        /* ------- process the comment-on-your-vote ------- */
        if (!preg_match('/^\s*$/', $post['msgtext'])) {
//             $subj = $this->tally->getCommentSubj($oldUservote, $uservote, $this);
//             $q = "INSERT msgs SET
//                     subj = '$subj',
//                     msgtext = '$post[msgtext]',
//                     discoowner_id = $this->marea_id,
//                     in_reply_to = $this->orig_preface_msg_id,
//                     when_posted = NOW(),
//                     thread_depth = 1,
//                     author = '$username',
//                     primary_ref_id = $this->orig_preface_ref_id";
//             $db->query($q);
//             $res['reload_msglist_at_msg_id'] = $db->getOne("SELECT LAST_INSERT_ID()");

            $uservote->msgtext = stripslashes($post['msgtext']);
            $q = "UPDATE userpolls SET msgtext = '$_POST[msgtext]'
                  WHERE username='$username' AND poll_id=$this->poll_id";
            $db->query($q);
        } else {
            //we wanna deset it.
            $q = "UPDATE userpolls SET msgtext = ''
                  WHERE username='$username' AND poll_id=$this->poll_id";
            $db->query($q);
        }
        return $res;
        
    }  /* --------------- end process Vote Submission () --------------- */

    function tallyNewVoteThenUpdate($db, $oldUservote, $newUservote) {
        $this->tally->tallyNewVote($oldUservote, $newUservote);
        $ser = addslashes(serialize($this->tally));
        $q = "UPDATE polls SET tally='$ser' WHERE poll_id = $this->poll_id";
        $db->query($q);
    }


    function makeDefaultVoteData() {
        //calls the appropriate one from Decisions.php
        //polymorphism the shitty php string-concatting way
        //(I don't dare use php "object orientation" for such a thing)
        $prop_ids = array_keys($this->props);
        $funcname = "makeDefaultVoteData_".$this->method_type;
        $ret = call_user_func($funcname, $prop_ids);
        return $ret;
    }

        
}



