<?php
require_once "../lib/DB.php";
//common.php should already be included


function dbinit_meta_connect()
{
    global $CONF;

    return dbinit_connect($CONF['DBUSER'], $CONF['DBPASS'], $CONF['DBHOST'], $CONF['META_DBNAME']);
}

// /*
//  * Connects to the group database of $group_name
//  * For elaborate multi-host database server setups, this function
//  * would have to change.
//  */
// function dbinit_group_connect($group_name)
// {
//     global $CONF;
//     $dsn = $CONF['DBUSER']
//         .":".$CONF['DBPASS']
//         ."@".$CONF['DBHOST']
//         ."/".$group_name;
//     return dbinit_dsn_connect($dsn);
// }



function dbinit_error_callback($error)
{
    echo "---- PEAR error!<BR><BR>\n";
    echo nl2br($error->getMessage()) . " <BR>\n";
    echo nl2br($error->getDebugInfo()) . " <BR>\n";
    echo "<BR>---- end PEAR error message. <BR>\n";
    
    die();
}

function error_callback_whenlocked($error)
{
    global $db;
    
    echo "---- db error!<BR><BR>\n";
    echo nl2br($error->getMessage()) . "<BR>\n";
    echo nl2br($error->getDebugInfo()) . "<BR>\n";
    echo "<BR>---- end db error message.<BR>\n";
    $db->query("UNLOCK TABLES");
    echo "---- Unlocked tables, now exiting<BR>";
    die();
}

function dbinit_connect($dbuser, $dbpass, $dbhost, $dbname)
{
    $dsn = "mysql://$dbuser:$dbpass@$dbhost/$dbname";
    $db = DB::connect($dsn, true);  //persistent=true
    if(DB::isError($db)) {
        user_error("Error connecting to database.<BR>\n".nl2br($db->getMessage()));
        die;
    }
    
    $db->setFetchMode(DB_FETCHMODE_ASSOC);
    $db->setErrorHandling(PEAR_ERROR_CALLBACK, 'dbinit_error_callback');
    
    return $db;
}



// ***** miscellaneous database stuff *****

// TODO: switch to a non-commandline way of doings things just from
// PEAR DB or mysql query php statements.  I didn't use PEAR because
// the DB::query() doesn't seem to like semi-colon separated strings
// of multiple statements -- which is what a mysql dump is!
// commandline is more straightforward.

// To get this running via the PEAR DB interface, maybe we have to parse
// out comments and separate via semicolons ourselves, then feed in each
// statement individually to a DB::query() call.


//Usage:  dbinit_run_dumpfile("deme_littlegroup", "../offweb/group.dump.sql")
function dbinit_run_dumpfile($dbname, $filename)
{
    $mysqlcmd = dbinit_mysql_command();
    $cmd = "$mysqlcmd \"$dbname\" < \"$filename\"";
//    printr($cmd);

    $output = array();
    $return_val = 0;
    exec($cmd, $output, $return_val);

    //0 means everything went right...
    if($return_val != 0) {
        trigger_error("The command returned $return_val: $cmd\n");
        $output = implode('\n', $output);
        trigger_error("Command's output was: $output\n");
    }
    
}

//Returns string that starts off a commandline mysql call
function dbinit_mysql_command()
{
    global $CONF;
    $u = $CONF['DBUSER'];
    $p = $CONF['DBPASS'];
    $h = $CONF['DBHOST'];
    
    return "mysql -u \"$u\"  -p\"$p\" -h \"$h\" ";
}

function dbinit_mysqladmin_command()
{
    global $CONF;
    $u = $CONF['DBUSER'];
    $p = $CONF['DBPASS'];
    $h = $CONF['DBHOST'];

    return "mysqladmin -u \"$u\"  -p\"$p\" -h \"$h\" ";
}

?>