<?
require_once "../lib/Emailer.php";


function maketest($datetime, $leftbound, $rightbound)
{
    return sprintf("(unix_timestamp('$leftbound') <= unix_timestamp(%s) AND
                     unix_timestamp(%s) <= NOW())",
//                     unix_timestamp(%s) <= unix_timestamp('$rightbound'))",
                   $datetime, $datetime);
}



/**
 * @param $mode: must be "daily" (for now) ..
 *  later will implement: "weekly", "monthly", etc.
 */
function groupDigest($group, $metadb, $mode)
{
    global $CONF, $CURGROUP;
    $CURGROUP = $group;
    echo $CURGROUP->getName() . "\n";
    
    $db = $group->getDB();
    
    if ($mode=='daily') {
        $yesterday_date = $db->getOne("select date_sub(curdate(), interval 1 day)");
//    $todays_date= $db->getOne("select curdate()");
        $lb  = "$yesterday_date 00:00:00";  //leftbound
        $rb  = "$yesterday_date 23:59:59";  //rightbound
        $digest_date = strftime("%x", strtotime($yesterday_date));
    } else {
        //We would implement just by changing the left/right bound, yes?..
        trigger_error("Don't know how to do non-daily digests yet");
    }
    
    
    
    
    $msgs_q = "SELECT author, subj, discoowner_id, msg_id FROM msgs
           WHERE ".maketest("when_posted", $lb, $rb);
    $msgs_res = $db->query($msgs_q);
    if ($msgs_res->numRows() == 0) {
        //Nothing new to report!
        return;
    }
    
    $docs_q = "SELECT orig_author, orig_preface_msg_id, marea_id, fi.title
           FROM docs 
                     LEFT JOIN folio_items fi ON
                       fi.indiv_type_id = docs.doc_id
           WHERE ".maketest("when_created", $lb, $rb);
    $docs_res = $db->query($docs_q);
    
    $mareas_q = "SELECT long_name, marea_id FROM mareas
             WHERE ".maketest("when_created", $lb, $rb);
    $mareas_res = $db->query($mareas_q);
    
    
    $msg = $mode=='daily'
        ? "This is a summary of yesterday's activity for {$digest_date}.\n"
        : "This is a summary of this past week's activity for {$digest_date}.\n";
    $msg .= "\n";
    
    
// ----- new mareas ----- 
    if ($c = $mareas_res->numRows()) {
        $msg .= "$c new meeting areas created:\n";
        while($row = $mareas_res->fetchRow()) {
            $url = $group->getUrlRoot()."/marea/?marea_id=$row[marea_id]";
            $msg .= " * \"$row[long_name]\": $url\n";
        }
    }
    
    $msg .= "\n\n";
    
    if ($c = $docs_res->numRows()) {
        $msg .= "$c new documents created:\n";
        while($row = $docs_res->fetchRow()) {
            $url = $group->getUrlRoot()."/marea/?";
            $url .= "marea_id=$row[marea_id]";
            $url .= "&msg_id=$row[orig_preface_msg_id]";
            $msg .= " * \"$row[title]\" created by $row[orig_author]: ";
            $msg .= "$url\n";
        }
    }
    
    $msg .= "\n\n";
    
    $c = $msgs_res->numRows();
    if($c == 0) {
        trigger_error("shouldnt get this far on no new comments", E_USER_WARNING);
        $msg .= "No new comments posted.\n";
    } else {
        $msg .= "$c new comments posted:\n";
        while($row = $msgs_res->fetchRow()) {
            $url = $group->getUrlRoot()."/marea/?";
            $url .= "marea_id=$row[discoowner_id]";
            $url .= "&msg_id=$row[msg_id]";
            
            $msg .= " * $row[author]: \"$row[subj]\"\n";
            $msg .= "    $url\n";
        }
    }
    
    
    $e = new Emailer;
    $username_rows = $db->getAll("SELECT username FROM users 
                      WHERE wants_".$mode."_digests = 1
                      ");
    var_dump($username_rows);
    
    $quoted_usernames = array();
    foreach($username_rows as $row) {
        $quoted_usernames[] = "'" .addslashes($row['username']) ."'";
    }
    
    $rows = Array();
    print_r($quoted_usernames);
    if($quoted_usernames) {
        $usernames_sql = "(" .implode(",", $quoted_usernames). ")";
        
        $res = $metadb->query(
            "SELECT firstname,lastname,email FROM users
                    WHERE username IN $usernames_sql
                    AND email != \"\"");
        while($row = $res->fetchRow()) {
            $rows[] = $row;
        }
    }
    
    print_r($rows);
    $e->setRecipientsFromRows($rows);
    $e->setSubject("Daily Summary for $digest_date");
    $e->setTextMessage($msg);
    $e->send();   
}
?>
