<?
require_once "../lib/common.php";
require_once "../lib/DemeAuth.php";
/* 

if($_SERVER['QUERY_STRING'] == 'forcelogin=1' && $a->getAuth()) {
    $url = dirname($_SERVER['SCRIPT_NAME']);
    header("Location: $url");
    exit;
}
*/

//Gotta be legal DNS name.

// the javascript and php functions should be maintained in sync.
// Javascript checking is nicer, but the php side has to check
// again, in case of broken javascript or malicious attacks.
// And don't forget, lib/jslib.php can help out to maintain in-sync codebases
// [though it's not needed here... yet.]

function jsAbbrevFullTitle() {
    
    //Only a suggestion.  user can change.
    // the /g flag at end of a regex means, do the replacement not just once
    // but for every occurrence in here.

    return "
    function abbrevFullTitle(fullTitle) {
        var s = fullTitle;
        s = cleanGroupName(s);
        if( s.length > 12) {
            s = s.substr(0,11);
        }
        return s
    }
    
    function cleanGroupName(name) {
        var s = name;
        s = s.replace(/\s+/g, / /); //collapse whitespace to 1 char
        s = s.replace(/ /g, '-'); //dashes not spaces
        s = s.replace(/[^0-9a-zA-Z]/g, '-'); //other shit to dashes
       // s = s.substring(0, 11); //makes sure no name is ever over 11 chars long
        return s;
    }
    "
    
    ;
}

//same thing php style
function abbrevFullTitle($fullTitle) {
    $s = $fullTitle;
    
    $s = preg_replace('/\s+/', ' ', $s);
    $s = preg_replace('/ /', '-', $s);
    $s = preg_replace('/[^0-9a-zA-Z]/', '-', $s);
    $s = substr($s, 0, 11);

    return $s;
}


function doesMAreaAlreadyExist($shortTitleName) {
    global $CURGROUP;
    require_once "../lib/dbinit.php";
    $db = $CURGROUP->getDB();
    $result = $db->query("SELECT short_name, long_name FROM mareas");
    while ($row = $result->fetchRow()){
        $existingGroupName = $row['short_name'];
        //i-flag indicates case insensitive search.
        if (preg_match("/^$existingGroupName$/i", $shortTitleName))
            return true;
    }
    return false;
}
/*
//Some of these we don't want polluting the subdomain space
//Others are here for whatever reason
$bannedGroupNames = array(
    "www", "ftp", "cvs", "mail", "download", "svn", "deme", "development", "dev" // potential subdomains 
    
);
*/
function isGroupNameLegal($s) {
  //global $bannedGroupNames;
  //if( in_array($s, $bannedGroupNames)) { return false; }
    if( preg_match('/[^a-zA-Z0-9\-]/', $s) ) { return false; }
    return true;
}
function printCheckName() {
  if ($_REQUEST['shortname'] == ""){
    echo "You did not enter a group shortname, please fill out the group shortname field and try again.";
  }
  else {
    if (doesMAreaAlreadyExist($_REQUEST['shortname'])){
      echo "Sorry.  The meeting area shortname \"".$_REQUEST['shortname']."\" is not available.  Please try another name.";
    } else {
      echo "The meeting area shortname \"".$_REQUEST['shortname']."\" is free for your use.";
    }
  }
}

$a = new DemeAuth("", true, true);
$a->start();
if( isset($_REQUEST['checkname'])) {
  printCheckName();
  exit();
}
if( ! isset($_REQUEST['submit'])) {
    printPage("");
    exit();
}


if(isset($_REQUEST['submit']) && 
   isset($_REQUEST['MAreaFullTitle']) && 
   (!isset($_REQUEST['MAreaName']) || ($_REQUEST['MAreaName'] == ""))) {
    
    $name = abbrevFullTitle( $_REQUEST['MAreaFullTitle'] );
    $_REQUEST['MAreaName'] = $name;
}

assert (isset($_REQUEST['submit']));
if(isset($_REQUEST['submit'])) {
  
    /*Possible errors that could result from this implementation:
      -users could clobber previous group installations.
      -users could clobber the code directory or other important directories
       add fixes here eventually...
    */
    $error_msg = "";
    if (!isGroupNameLegal($_REQUEST['MAreaName'])) {
        $error_msg .= "<b>Your title contained illegal characters.  Try again.</b><br>";
    } else if (doesMAreaAlreadyExist($_REQUEST['MAreaName'])) {
        $error_msg .= "<b>That meeting area name already exists, please try another name</b>";
    }

    if( $error_msg ) {
        printPage($error_msg);
        exit();
    } else {
      //ENTER CODE TO PHYSICALLY MAKE THE GROUP
      //some of the entries below are hardcoded because the features they refer to are unimplemented.
      $insertq = "INSERT mareas SET 
    short_name = '$_POST[MAreaName]',
    long_name = '$_POST[MAreaFullTitle]',
    owner_id = '1',
    perms_type = 'everyone',
    when_created = NOW()";
      
      
      
      //echo "$insertq<BR>";
      require_once "../lib/dbinit.php";
      $db = $CURGROUP->getDB();
      $db->query($insertq);
      $marea_id = $db->getOne("SELECT LAST_INSERT_ID()");
      
      echo "<P>The new meeting area has been created!";
      echo "<P><B><a href=../marea/?marea_id=".$marea_id.">";
      echo "Enter the meeting area</a></b>";
      echo "<P><a href=..>Go back to home</a><BR><BR>";
      exit();
    }
}
      
function printPage( $error_msg )
{
    global $CURGROUP, $CONF;
    echo "<html>
<head>
<script>

MAreaNameNeverHadFocusYet = true;

function MAreaFullTitle_onchange() {
    curtext = document.getElementById('theform').MAreaName.value;
    if(MAreaNameNeverHadFocusYet && curtext == '') {
        MAreaName_FillFromFullTitle();
    } else {
    }
}
function MAreaName_onfocus() {
        MAreaNameNeverHadFocusYet = false;
}

";

    echo jsAbbrevFullTitle();

    echo "
function MAreaName_FillFromFullTitle() {
    fullTitle = document.getElementById('theform').MAreaFullTitle.value;
    var s = abbrevFullTitle(fullTitle);

    document.getElementById('theform').MAreaName.value = s;
    updateUrlDisplay();
}

function MAreaName_onchange() {
    updateUrlDisplay();
}

function MAreaName_onkeyup() {
    curtext = document.getElementById('theform').MAreaName.value;
    curtext = cleanGroupName(curtext);
    document.getElementById('theform').MAreaName.value = curtext;
    updateUrlDisplay();
}
";

echo "
function updateUrlDisplay() {
    var elt = document.getElementById('theform').MAreaName;
    var lessDiv = document.getElementById('less');
    var shortname = elt.value;
    cleaned = cleanGroupName(shortname);
    if (shortname.length >= 12) {
      lessDiv.style.backgroundColor = 'orange';
      elt.style.backgroundColor = 'orange';
    }
    else { 
      lessDiv.style.backgroundColor = 'white';
      elt.style.backgroundColor = 'white';
    }
    subdom = cleaned.toLowerCase();
    
    //TODO: the subdomain naming scheme should be optional.  and not hardocoded to groupspace.org.
    subdom_show = subdom ? subdom : '_____';
    dnsname = subdom_show + '@".$CURGROUP->getName().$CONF['DOMAIN_SUFFIX']."';
    subdomview = document.getElementById('MAreaSubdomainView');
    if(subdomview)
        subdomview.innerHTML = dnsname;

}
";
    echo "
function checkIfMAreaNameIsTaken() {
  var shortname = document.getElementById('theform').MAreaName.value;
  url = \"newmarea.php\" + \"?shortname=\" + shortname + \"&checkname=true\";

    //Buggy with certain dual-screen setups
    newheight = Math.floor(screen.availHeight / 8);
    newwidth =  Math.floor(screen.availWidth / 2);
    var myPopupPost = window.open(
			      /* Arg #1 to window.open(): URL */
			      url,
			      
			      /* Arg #2 to window.open(): popup framename. */
			      \"check_post\",
			      
			      /* Arg #3, list of options in that hacky comma-string format */
			      \"width=\"+newwidth+\",height=\"+newheight+\",resizable=yes,menubar=no,scrollbars=yes\");
    myPopupPost.focus();
}
";

//Commenting out an unsafe javascript function:
/*echo "

function checkIfMAreaNameIsTaken(submitted) {
  //Potential flaw with this implementation: a savy user would know all of the short group name on any given installation of Deme.  This shouldn't be that dangerous because in theory our system is secure enough that this information should not aid an attack; however, it's something to consider. 
";

  require_once "code/lib/dbinit.php";
  $metadb = dbinit_meta_connect();
  $result = $metadb->query("SELECT name FROM groups");
  $resultSize = $result->numRows();

echo"  
  var listOfGroups = new Array(".$resultSize."); 
  ";
 $i = 0; 
while ($row = $result->fetchRow()){
   $existingGroupName = $row['name'];
   echo "
     listOfGroups[".$i."] = \"".$existingGroupName."\";
   ";
   $i++;
 }

echo "
   //stopped here: need to insert code to check the proposed shortname to the list of shortnames.
   var shortName = document.getElementById('theform').MAreaName.value;
   var isTaken = false;

var i = 0;
for (i = 0; i < ".$resultSize."; i++){
  if (shortName.toLowerCase() == listOfGroups[i].toLowerCase())
  isTaken = true;
}

   if (isTaken){
 alert(\"Sorry!  That short name is taken; please choose another one.\");
 return false;
} else {
  if (!submitted) {
    alert(\"That name is not taken.\");
  }
 return true;
}
   //alert(\"Unimplemented.  TODO: a cool javascript request.  xmlhtttprequest is the most proper way to do it, but a hacky solution could work fine and be less complex to figure out.\");

}
";
*/



    echo "

    
</script>
<title>Create a new meeting area</title>
</head>

<body>
<h2>Create a new meeting area </h2>

$error_msg

<form method=\"post\" action=\"newmarea.php\" id=\"theform\">
<p> Enter the full name of the new meeting area (use only alphanumeric characters and spaces):
<br><input type=\"text\" name=\"MAreaFullTitle\"
     onchange=\"MAreaFullTitle_onchange();\"> 
<br>
<P>Enter a short name or abbreviation for the meeting area.<br>
This should be <span id=\"less\">less than 12 characters long.</span><br>
The only allowed characters are letters, numbers, and the
dash character: <b>-</b>

<br><input type=\"text\" name=\"MAreaName\" 
     onfocus=\"MAreaName_onfocus();\"
     onchange=\"MAreaName_onchange();\"
     onkeyup=\"MAreaName_onkeyup(); return true;\">
    <span id=\"MAreaNameCount\"></span>
&nbsp;
<a href=# onclick=\"checkIfMAreaNameIsTaken()\">Is this short name available?</a>
";

if( $CONF['EMAIL_INPUT'] )

    echo "
<br>   
Meeting area email address will look like: <b><span style=\"font-family: arial, sans-serif; font-size:80%;\" id=\"MAreaSubdomainView\">
_____@". strtolower($CURGROUP->getName()) . $CONF['DOMAIN_SUFFIX']  ."</span></b>
<br>
<br>";


echo"
<br><br>
<input type=\"submit\" name=\"submit\" value=\"Submit\">
</form>
</body>
</html>";
}

?>
