<?
require_once "../lib/common.php";
require_once "../lib/DemeAuth.php";
require_once "../lib/dbinit.php";
require_once "../lib/Group.php";
require_once "../lib/htmlutil.php";
require_once "../lib/userinfo.php";

/**
 * Possible GET variables
 * mode: 'meta' or 'group'
 * group: group shortname, if mode is 'group'
 * changeopts: 1 if exists
 */

//Determine whether we're in meta or per-group mode
if( ! isset($_REQUEST['mode']) ) {
    fatalPageError("must be a mode var, and it must be either 'meta' or 'group'");
} else if($_REQUEST['mode'] == 'meta' || $_REQUEST['mode'] == 'group') {
    $mode = $_REQUEST['mode'];
} else {
    fatalPageError("mode var must be either 'meta' or 'group'");
}

$metadb = dbinit_meta_connect();

if($mode == 'group') {
    if( !isset($_REQUEST['group']))
        fatalPageError("mode=group, but no group var set");

    //Set CURGROUP
    $CURGROUP = Group::fetchGroupByName($metadb, $_REQUEST['group']);
    if( !$CURGROUP) 
        fatalPageError("Failed to fetch group '$_REQUEST[group]'");
}

$auth = "";
if($mode == 'meta') {
  $auth = new DemeAuth("", true, true);
} else {
  $auth = new DemeAuth();
}

$auth->start();


function print_back_to_home()
{
    global $mode;
    if($mode == 'group') {
        global $CURGROUP;
        $url = $CURGROUP->getTopUrl();
        echo "<a href=\"$url\">&lt;-- Back to group home page</a>";
    } else
        echo "<a href=\"userhome.php\">&lt;-- Back to your home page</a>";
}
?>
<HTML>
<HEAD>
<TITLE>Settings and Profile</TITLE>
<STYLE>
.key {
    font-weight: bold;
    text-align: right;
}
.reenter_label {
    font-color: red;
}
</STYLE>

</HEAD>
<BODY>
<?

if ($auth->getUsername() == "guest") {
    echo "<center>";
    echo "<P>The guest account has no settings to change.";
    echo "<P><a href=\"javascript:history.back();\">Go Back</a>";
    echo "</center>";
    exit;
}

echo "<h1><B>";
echo $auth->getUsername();
echo "</B>'s settings and profile</h1>";

$db = "";
if($mode == 'group') {
    $db = $CURGROUP->getDB();
}

function getUserRow($db)
{
    global $auth;
    $row = $db->getRow("SELECT * FROM users WHERE username = '" .$auth->getUsername(). "'");
    return $row;
}

$user_grouprow = "";
if($mode == 'group') {
    $user_grouprow = getUserRow($CURGROUP->getDB());
}
$user_metarow = getUserRow($metadb);


function make_input_field($dbname, $dbval)
{
    global $booleans_boolset, $textareas;
    if (isset($booleans_boolset[$dbname])) {
        $r = "<SELECT name=$dbname>";
        if ((bool)$dbval) {
            $r .= "<OPTION value=1 selected=\"selected\">Yes</OPTION>";
            $r .= "<OPTION value=0>No</OPTION>";
        }else {
            $r .= "<OPTION value=1>Yes</OPTION>";
            $r .= "<OPTION value=0 selected=\"selected\">No</OPTION>";
        }
        $r .= "</SELECT>";
        return $r;
    }

    if (isset($textareas[$dbname])) {
        $dimensions = $textareas[$dbname];
        $r = $dimensions[0];
        $c = $dimensions[1];
        return "<textarea name=$dbname rows=$r cols=$c>".
            htmlspecialchars($dbval).
            "</textarea>";
    }
        
    return "<input type=text name=$dbname value=\"".
        htmlspecialchars($dbval).
        "\">";
}

//dumpreq();
function show_static_table($userrow) {
    global $db_human_names;
    echo "<table>";
    foreach($db_human_names as $dbname => $humname) {
        if(isset($userrow[$dbname])) {
            $val = printable_val($dbname, $userrow[$dbname]);
            echo "<tr valign=top><td class=key>$humname: &nbsp; <td class=value>";
            echo smart_htmlize($val);
        }
    }
    echo "</table>";
}

function show_current_settings() {
    global $db, $metadb, $mode,  $CURGROUP;
    if($mode == 'group') {
        $user_grouprow = getUserRow($CURGROUP->getDB());
        echo "<h2>Your settings for the group: " .$CURGROUP->getLongName()."</h2>";
        show_static_table($user_grouprow);
        echo "<br><a href=$_SERVER[PHP_SELF]?mode=group&group=".$_REQUEST['group']."&changeopts=1>";
        echo "Change</a>";

    } else if($mode == 'meta') {
        echo "<h2>My Profile</h2>";
        echo "Your profile can be seen by all registered Deme users.<br><br>";
        $user_metarow = getUserRow($metadb);
        show_static_table($user_metarow);
        echo "<br><a href=$_SERVER[PHP_SELF]?mode=meta&changeopts=1>";
        echo "Change</a>";
        echo "<hr>";
        echo "<h2>Other settings</h2>";
        echo "<a href=changepw.php>Change password</a>";
    }

    echo "<hr>";
    print_back_to_home();
}


function show_settings_form() {
    global $mode,
        $meta_vars_boolset, $group_vars_boolset,
        $user_metarow, $user_grouprow,
        $db_human_names;

    $vars = $mode=='meta' ? $meta_vars_boolset : $group_vars_boolset;
    $vals = $mode=='meta' ? $user_metarow : $user_grouprow;
    
    echo "<FORM method=POST>";
    echo "<table>";

    
    foreach($vars as $dbname => $bla) { //db_human_names as $dbname => $humname) {
        $humname = $db_human_names[$dbname];
        $dbval = $vals[$dbname];

        $input_field = make_input_field($dbname, $dbval);
        echo "<tr valign=top>";
        echo  "<td class=key>$humname: </td>";
        echo  "<td class=value>$input_field</td>";
        
    }
    echo "</table>";


    //Password change code WAS here; migrated to meta/changepw.php
    
    echo "<input type=submit name=submit value=\"Make these changes\">";
    echo "</FORM>";
}

if (!isset($_REQUEST['changeopts'])) {
    show_current_settings();
    //show_member_groups();
    
} else if (!isset($_REQUEST['submit']) &&
            isset($_REQUEST['changeopts']) && $_REQUEST['changeopts']) {

    show_settings_form();

} else if (isset($_REQUEST['submit']) &&
           isset($_REQUEST['changeopts']) && $_REQUEST['changeopts']) {

    $pairs = array();
    $vars = $mode=='meta' ? $meta_vars_boolset : $group_vars_boolset;

    foreach($_POST as $k=>$v) {
        if($k == 'submit') {
            continue;
        } else if(isset($vars[$k])) {
            // $v is already slashed out
            $pairs[] = "$k='$v'";
        } else {
            //everything shoulda fallen into one of those categories
            pageFatalError("Got a bad variable passed in: '$k'='$v'");
        }
    }

    $setsql = join(",", $pairs);
    $username = $auth->getUsername();
    $q = "UPDATE users SET $setsql WHERE username='$username'";
    
    if($mode == 'group') {
      $db->query($q);
    } else {
        $metadb->query($q);
    }

    echo "Your settings have been saved.OA";
//    print_back_to_home();
    echo "<HR>";
    show_current_settings();
    // show_member_groups();
}
echo "</BODY></HTML>";



/************************
    $pairs_for_meta = array();
    $pairs_for_group = array();

    foreach($_POST as $k=>$v) {
        if($k == 'submit' || $k=='password1' || $k=='password') {
            continue;
        } else if(isset($meta_vars_boolset[$k])) {
            $pairs_for_meta[] = "$k='$v'";
        } else if(isset($group_vars_boolset[$k])) {
            $pairs_for_group[]= "$k='$v'";
        } else {
            //everything shoulda fallen into one of those categories
            assert(false);
        }
    }

    $setsql_meta = join(",", $pairs_for_meta);
    $setsql_group = join(",", $pairs_for_group);
    $username = $user_metarow['username'];
    if(!isset($_REQUEST['meta'])) {
      $q = "UPDATE users SET $setsql_group WHERE username='$username'";
      //    echo $q;
      $db->query($q);
    }
    $q = "UPDATE users SET $setsql_meta WHERE username='$username'";
    $metadb->query($q);
******************************/